#define UNTRACK_ENTER Runtime::Current()->GetProbeManager()->UntrackEnter(true);

#define UNTRACK_EXIT Runtime::Current()->GetProbeManager()->UntrackExit(true);

#define WRAP_FUNCTION(func_name, func_invoc)	\
  auto wrap_check_##func_name			\
  NO_THREAD_SAFETY_ANALYSIS {			\
    UNTRACK_ENTER;				\
    auto res = CheckJNI::func_invoc;		\
    UNTRACK_EXIT;		     		\
    return res;				\
  }

#define WRAP_VARIADIC_FUNCTION(func_name, func_invoc, last_arg_name)	\
  auto wrap_check_##func_name						\
  NO_THREAD_SAFETY_ANALYSIS {						\
    va_list ap;							\
    va_start(ap, last_arg_name);					\
    UNTRACK_ENTER;							\
    auto res = CheckJNI::func_invoc;					\
    UNTRACK_EXIT;							\
    va_end(ap);							\
    return res;							\
  }

#define WRAP_VOID_FUNCTION(func_name, func_invoc)	\
  void wrap_check_##func_name				\
  NO_THREAD_SAFETY_ANALYSIS {				\
    UNTRACK_ENTER;					\
    CheckJNI::func_invoc;				\
    UNTRACK_EXIT;					\
  }

#define WRAP_VARIADIC_VOID_FUNCTION(func_name, func_invoc, last_arg_name) \
  void wrap_check_##func_name						\
  NO_THREAD_SAFETY_ANALYSIS {						\
    va_list ap;							\
    va_start(ap, last_arg_name);					\
    UNTRACK_ENTER;							\
    CheckJNI::func_invoc;						\
    UNTRACK_EXIT;							\
    va_end(ap);							\
  }
WRAP_FUNCTION(GetVersion(JNIEnv * env), GetVersion(env))
WRAP_FUNCTION(DefineClass(JNIEnv* env, const char* b, jobject c, const jbyte* d, jsize e), DefineClass(env,b,c,d,e))
WRAP_FUNCTION(FindClass(JNIEnv* env, const char* b), FindClass(env,b))
WRAP_FUNCTION(FromReflectedMethod(JNIEnv* env, jobject b), FromReflectedMethod(env,b))
WRAP_FUNCTION(FromReflectedField(JNIEnv* env, jobject b), FromReflectedField(env,b))
WRAP_FUNCTION(ToReflectedMethod(JNIEnv* env, jclass b, jmethodID c, jboolean d), ToReflectedMethod(env,b,c,d))
WRAP_FUNCTION(GetSuperclass(JNIEnv* env, jclass b), GetSuperclass(env,b))
WRAP_FUNCTION(IsAssignableFrom(JNIEnv* env, jclass b, jclass c), IsAssignableFrom(env,b,c))
WRAP_FUNCTION(ToReflectedField(JNIEnv* env, jclass b, jfieldID c, jboolean d), ToReflectedField(env,b,c,d))
WRAP_FUNCTION(Throw(JNIEnv* env, jthrowable b), Throw(env,b))
WRAP_FUNCTION(ThrowNew(JNIEnv * env, jclass b, const char * c), ThrowNew(env,b,c))
WRAP_FUNCTION(ExceptionOccurred(JNIEnv* env), ExceptionOccurred(env))
WRAP_VOID_FUNCTION(ExceptionDescribe(JNIEnv* env), ExceptionDescribe(env))
WRAP_VOID_FUNCTION(ExceptionClear(JNIEnv* env), ExceptionClear(env))
WRAP_VOID_FUNCTION(FatalError(JNIEnv* env, const char* b), FatalError(env,b))
WRAP_FUNCTION(PushLocalFrame(JNIEnv* env, jint b), PushLocalFrame(env,b))
WRAP_FUNCTION(PopLocalFrame(JNIEnv* env, jobject b), PopLocalFrame(env,b))
WRAP_FUNCTION(NewGlobalRef(JNIEnv* env, jobject b), NewGlobalRef(env,b))
WRAP_VOID_FUNCTION(DeleteGlobalRef(JNIEnv* env, jobject b), DeleteGlobalRef(env,b))
WRAP_VOID_FUNCTION(DeleteLocalRef(JNIEnv* env, jobject b), DeleteLocalRef(env,b))
WRAP_FUNCTION(IsSameObject(JNIEnv* env, jobject b, jobject c), IsSameObject(env,b,c))
WRAP_FUNCTION(NewLocalRef(JNIEnv* env, jobject b), NewLocalRef(env,b))
WRAP_FUNCTION(EnsureLocalCapacity(JNIEnv* env, jint b), EnsureLocalCapacity(env,b))
WRAP_FUNCTION(AllocObject(JNIEnv* env, jclass b), AllocObject(env,b))
WRAP_VARIADIC_FUNCTION(NewObject(JNIEnv* env, jclass b, jmethodID c, ...), NewObjectV(env,b,c,ap), c)
WRAP_FUNCTION(NewObjectV(JNIEnv* env, jclass b, jmethodID c, va_list d), NewObjectV(env,b,c,d))
WRAP_FUNCTION(NewObjectA(JNIEnv* env, jclass b, jmethodID c, jvalue* d), NewObjectA(env,b,c,d))
WRAP_FUNCTION(GetObjectClass(JNIEnv* env, jobject b), GetObjectClass(env,b))
WRAP_FUNCTION(IsInstanceOf(JNIEnv* env, jobject b, jclass c), IsInstanceOf(env,b,c))
WRAP_FUNCTION(GetMethodID(JNIEnv* env, jclass b, const char* c, const char* d), GetMethodID(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallObjectMethod(JNIEnv* env, jobject b, jmethodID c, ...), CallObjectMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallObjectMethodV(JNIEnv* env, jobject b, jmethodID c, va_list d), CallObjectMethodV(env,b,c,d))
WRAP_FUNCTION(CallObjectMethodA(JNIEnv* env, jobject b, jmethodID c, jvalue* d), CallObjectMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallBooleanMethod(JNIEnv* env, jobject b, jmethodID c, ...), CallBooleanMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallBooleanMethodV(JNIEnv* env, jobject b, jmethodID c, va_list d), CallBooleanMethodV(env,b,c,d))
WRAP_FUNCTION(CallBooleanMethodA(JNIEnv* env, jobject b, jmethodID c, jvalue* d), CallBooleanMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallByteMethod(JNIEnv* env, jobject b, jmethodID c, ...), CallByteMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallByteMethodV(JNIEnv* env, jobject b, jmethodID c, va_list d), CallByteMethodV(env,b,c,d))
WRAP_FUNCTION(CallByteMethodA(JNIEnv* env, jobject b, jmethodID c, jvalue* d), CallByteMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallCharMethod(JNIEnv* env, jobject b, jmethodID c, ...), CallCharMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallCharMethodV(JNIEnv* env, jobject b, jmethodID c, va_list d), CallCharMethodV(env,b,c,d))
WRAP_FUNCTION(CallCharMethodA(JNIEnv* env, jobject b, jmethodID c, jvalue* d), CallCharMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallShortMethod(JNIEnv* env, jobject b, jmethodID c, ...), CallShortMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallShortMethodV(JNIEnv* env, jobject b, jmethodID c, va_list d), CallShortMethodV(env,b,c,d))
WRAP_FUNCTION(CallShortMethodA(JNIEnv* env, jobject b, jmethodID c, jvalue* d), CallShortMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallIntMethod(JNIEnv* env, jobject b, jmethodID c, ...), CallIntMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallIntMethodV(JNIEnv* env, jobject b, jmethodID c, va_list d), CallIntMethodV(env,b,c,d))
WRAP_FUNCTION(CallIntMethodA(JNIEnv* env, jobject b, jmethodID c, jvalue* d), CallIntMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallLongMethod(JNIEnv* env, jobject b, jmethodID c, ...), CallLongMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallLongMethodV(JNIEnv* env, jobject b, jmethodID c, va_list d), CallLongMethodV(env,b,c,d))
WRAP_FUNCTION(CallLongMethodA(JNIEnv* env, jobject b, jmethodID c, jvalue* d), CallLongMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallFloatMethod(JNIEnv* env, jobject b, jmethodID c, ...), CallFloatMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallFloatMethodV(JNIEnv* env, jobject b, jmethodID c, va_list d), CallFloatMethodV(env,b,c,d))
WRAP_FUNCTION(CallFloatMethodA(JNIEnv* env, jobject b, jmethodID c, jvalue* d), CallFloatMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallDoubleMethod(JNIEnv* env, jobject b, jmethodID c, ...), CallDoubleMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallDoubleMethodV(JNIEnv* env, jobject b, jmethodID c, va_list d), CallDoubleMethodV(env,b,c,d))
WRAP_FUNCTION(CallDoubleMethodA(JNIEnv* env, jobject b, jmethodID c, jvalue* d), CallDoubleMethodA(env,b,c,d))
WRAP_VARIADIC_VOID_FUNCTION(CallVoidMethod(JNIEnv* env, jobject b, jmethodID c, ...), CallVoidMethodV(env,b,c,ap), c)
WRAP_VOID_FUNCTION(CallVoidMethodV(JNIEnv* env, jobject b, jmethodID c, va_list d), CallVoidMethodV(env,b,c,d))
WRAP_VOID_FUNCTION(CallVoidMethodA(JNIEnv* env, jobject b, jmethodID c, jvalue* d), CallVoidMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallNonvirtualObjectMethod(JNIEnv* env, jobject b, jclass c, jmethodID d, ...), CallNonvirtualObjectMethodV(env,b,c,d,ap), d)
WRAP_FUNCTION(CallNonvirtualObjectMethodV(JNIEnv* env, jobject b, jclass c, jmethodID d, va_list e), CallNonvirtualObjectMethodV(env,b,c,d,e))
WRAP_FUNCTION(CallNonvirtualObjectMethodA(JNIEnv* env, jobject b, jclass c, jmethodID d, jvalue* e), CallNonvirtualObjectMethodA(env,b,c,d,e))
WRAP_VARIADIC_FUNCTION(CallNonvirtualBooleanMethod(JNIEnv* env, jobject b, jclass c, jmethodID d, ...), CallNonvirtualBooleanMethodV(env,b,c,d,ap), d)
WRAP_FUNCTION(CallNonvirtualBooleanMethodV(JNIEnv* env, jobject b, jclass c, jmethodID d, va_list e), CallNonvirtualBooleanMethodV(env,b,c,d,e))
WRAP_FUNCTION(CallNonvirtualBooleanMethodA(JNIEnv* env, jobject b, jclass c, jmethodID d, jvalue* e), CallNonvirtualBooleanMethodA(env,b,c,d,e))
WRAP_VARIADIC_FUNCTION(CallNonvirtualByteMethod(JNIEnv* env, jobject b, jclass c, jmethodID d, ...), CallNonvirtualByteMethodV(env,b,c,d,ap), d)
WRAP_FUNCTION(CallNonvirtualByteMethodV(JNIEnv* env, jobject b, jclass c, jmethodID d, va_list e), CallNonvirtualByteMethodV(env,b,c,d,e))
WRAP_FUNCTION(CallNonvirtualByteMethodA(JNIEnv* env, jobject b, jclass c, jmethodID d, jvalue* e), CallNonvirtualByteMethodA(env,b,c,d,e))
WRAP_VARIADIC_FUNCTION(CallNonvirtualCharMethod(JNIEnv* env, jobject b, jclass c, jmethodID d, ...), CallNonvirtualCharMethodV(env,b,c,d,ap), d)
WRAP_FUNCTION(CallNonvirtualCharMethodV(JNIEnv* env, jobject b, jclass c, jmethodID d, va_list e), CallNonvirtualCharMethodV(env,b,c,d,e))
WRAP_FUNCTION(CallNonvirtualCharMethodA(JNIEnv* env, jobject b, jclass c, jmethodID d, jvalue* e), CallNonvirtualCharMethodA(env,b,c,d,e))
WRAP_VARIADIC_FUNCTION(CallNonvirtualShortMethod(JNIEnv* env, jobject b, jclass c, jmethodID d, ...), CallNonvirtualShortMethodV(env,b,c,d,ap), d)
WRAP_FUNCTION(CallNonvirtualShortMethodV(JNIEnv* env, jobject b, jclass c, jmethodID d, va_list e), CallNonvirtualShortMethodV(env,b,c,d,e))
WRAP_FUNCTION(CallNonvirtualShortMethodA(JNIEnv* env, jobject b, jclass c, jmethodID d, jvalue* e), CallNonvirtualShortMethodA(env,b,c,d,e))
WRAP_VARIADIC_FUNCTION(CallNonvirtualIntMethod(JNIEnv* env, jobject b, jclass c, jmethodID d, ...), CallNonvirtualIntMethodV(env,b,c,d,ap), d)
WRAP_FUNCTION(CallNonvirtualIntMethodV(JNIEnv* env, jobject b, jclass c, jmethodID d, va_list e), CallNonvirtualIntMethodV(env,b,c,d,e))
WRAP_FUNCTION(CallNonvirtualIntMethodA(JNIEnv* env, jobject b, jclass c, jmethodID d, jvalue* e), CallNonvirtualIntMethodA(env,b,c,d,e))
WRAP_VARIADIC_FUNCTION(CallNonvirtualLongMethod(JNIEnv* env, jobject b, jclass c, jmethodID d, ...), CallNonvirtualLongMethodV(env,b,c,d,ap), d)
WRAP_FUNCTION(CallNonvirtualLongMethodV(JNIEnv* env, jobject b, jclass c, jmethodID d, va_list e), CallNonvirtualLongMethodV(env,b,c,d,e))
WRAP_FUNCTION(CallNonvirtualLongMethodA(JNIEnv* env, jobject b, jclass c, jmethodID d, jvalue* e), CallNonvirtualLongMethodA(env,b,c,d,e))
WRAP_VARIADIC_FUNCTION(CallNonvirtualFloatMethod(JNIEnv* env, jobject b, jclass c, jmethodID d, ...), CallNonvirtualFloatMethodV(env,b,c,d,ap), d)
WRAP_FUNCTION(CallNonvirtualFloatMethodV(JNIEnv* env, jobject b, jclass c, jmethodID d, va_list e), CallNonvirtualFloatMethodV(env,b,c,d,e))
WRAP_FUNCTION(CallNonvirtualFloatMethodA(JNIEnv* env, jobject b, jclass c, jmethodID d, jvalue* e), CallNonvirtualFloatMethodA(env,b,c,d,e))
WRAP_VARIADIC_FUNCTION(CallNonvirtualDoubleMethod(JNIEnv* env, jobject b, jclass c, jmethodID d, ...), CallNonvirtualDoubleMethodV(env,b,c,d,ap), d)
WRAP_FUNCTION(CallNonvirtualDoubleMethodV(JNIEnv* env, jobject b, jclass c, jmethodID d, va_list e), CallNonvirtualDoubleMethodV(env,b,c,d,e))
WRAP_FUNCTION(CallNonvirtualDoubleMethodA(JNIEnv* env, jobject b, jclass c, jmethodID d, jvalue* e), CallNonvirtualDoubleMethodA(env,b,c,d,e))
WRAP_VARIADIC_VOID_FUNCTION(CallNonvirtualVoidMethod(JNIEnv* env, jobject b, jclass c, jmethodID d, ...), CallNonvirtualVoidMethodV(env,b,c,d,ap), d)
WRAP_VOID_FUNCTION(CallNonvirtualVoidMethodV(JNIEnv* env, jobject b, jclass c, jmethodID d, va_list e), CallNonvirtualVoidMethodV(env,b,c,d,e))
WRAP_VOID_FUNCTION(CallNonvirtualVoidMethodA(JNIEnv* env, jobject b, jclass c, jmethodID d, jvalue* e), CallNonvirtualVoidMethodA(env,b,c,d,e))
WRAP_FUNCTION(GetFieldID(JNIEnv* env, jclass b, const char* c, const char* d), GetFieldID(env,b,c,d))
WRAP_FUNCTION(GetObjectField(JNIEnv* env, jobject b, jfieldID c), GetObjectField(env,b,c))
WRAP_FUNCTION(GetBooleanField(JNIEnv* env, jobject b, jfieldID c), GetBooleanField(env,b,c))
WRAP_FUNCTION(GetByteField(JNIEnv* env, jobject b, jfieldID c), GetByteField(env,b,c))
WRAP_FUNCTION(GetCharField(JNIEnv* env, jobject b, jfieldID c), GetCharField(env,b,c))
WRAP_FUNCTION(GetShortField(JNIEnv* env, jobject b, jfieldID c), GetShortField(env,b,c))
WRAP_FUNCTION(GetIntField(JNIEnv* env, jobject b, jfieldID c), GetIntField(env,b,c))
WRAP_FUNCTION(GetLongField(JNIEnv* env, jobject b, jfieldID c), GetLongField(env,b,c))
WRAP_FUNCTION(GetFloatField(JNIEnv* env, jobject b, jfieldID c), GetFloatField(env,b,c))
WRAP_FUNCTION(GetDoubleField(JNIEnv* env, jobject b, jfieldID c), GetDoubleField(env,b,c))
WRAP_VOID_FUNCTION(SetObjectField(JNIEnv* env, jobject b, jfieldID c, jobject d), SetObjectField(env,b,c,d))
WRAP_VOID_FUNCTION(SetBooleanField(JNIEnv* env, jobject b, jfieldID c, jboolean d), SetBooleanField(env,b,c,d))
WRAP_VOID_FUNCTION(SetByteField(JNIEnv* env, jobject b, jfieldID c, jbyte d), SetByteField(env,b,c,d))
WRAP_VOID_FUNCTION(SetCharField(JNIEnv* env, jobject b, jfieldID c, jchar d), SetCharField(env,b,c,d))
WRAP_VOID_FUNCTION(SetShortField(JNIEnv* env, jobject b, jfieldID c, jshort d), SetShortField(env,b,c,d))
WRAP_VOID_FUNCTION(SetIntField(JNIEnv* env, jobject b, jfieldID c, jint d), SetIntField(env,b,c,d))
WRAP_VOID_FUNCTION(SetLongField(JNIEnv* env, jobject b, jfieldID c, jlong d), SetLongField(env,b,c,d))
WRAP_VOID_FUNCTION(SetFloatField(JNIEnv* env, jobject b, jfieldID c, jfloat d), SetFloatField(env,b,c,d))
WRAP_VOID_FUNCTION(SetDoubleField(JNIEnv* env, jobject b, jfieldID c, jdouble d), SetDoubleField(env,b,c,d))
WRAP_FUNCTION(GetStaticMethodID(JNIEnv* env, jclass b, const char* c, const char* d), GetStaticMethodID(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallStaticObjectMethod(JNIEnv* env, jclass b, jmethodID c, ...), CallStaticObjectMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallStaticObjectMethodV(JNIEnv* env, jclass b, jmethodID c, va_list d), CallStaticObjectMethodV(env,b,c,d))
WRAP_FUNCTION(CallStaticObjectMethodA(JNIEnv* env, jclass b, jmethodID c, jvalue* d), CallStaticObjectMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallStaticBooleanMethod(JNIEnv* env, jclass b, jmethodID c, ...), CallStaticBooleanMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallStaticBooleanMethodV(JNIEnv* env, jclass b, jmethodID c, va_list d), CallStaticBooleanMethodV(env,b,c,d))
WRAP_FUNCTION(CallStaticBooleanMethodA(JNIEnv* env, jclass b, jmethodID c, jvalue* d), CallStaticBooleanMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallStaticByteMethod(JNIEnv* env, jclass b, jmethodID c, ...), CallStaticByteMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallStaticByteMethodV(JNIEnv* env, jclass b, jmethodID c, va_list d), CallStaticByteMethodV(env,b,c,d))
WRAP_FUNCTION(CallStaticByteMethodA(JNIEnv* env, jclass b, jmethodID c, jvalue* d), CallStaticByteMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallStaticCharMethod(JNIEnv* env, jclass b, jmethodID c, ...), CallStaticCharMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallStaticCharMethodV(JNIEnv* env, jclass b, jmethodID c, va_list d), CallStaticCharMethodV(env,b,c,d))
WRAP_FUNCTION(CallStaticCharMethodA(JNIEnv* env, jclass b, jmethodID c, jvalue* d), CallStaticCharMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallStaticShortMethod(JNIEnv* env, jclass b, jmethodID c, ...), CallStaticShortMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallStaticShortMethodV(JNIEnv* env, jclass b, jmethodID c, va_list d), CallStaticShortMethodV(env,b,c,d))
WRAP_FUNCTION(CallStaticShortMethodA(JNIEnv* env, jclass b, jmethodID c, jvalue* d), CallStaticShortMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallStaticIntMethod(JNIEnv* env, jclass b, jmethodID c, ...), CallStaticIntMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallStaticIntMethodV(JNIEnv* env, jclass b, jmethodID c, va_list d), CallStaticIntMethodV(env,b,c,d))
WRAP_FUNCTION(CallStaticIntMethodA(JNIEnv* env, jclass b, jmethodID c, jvalue* d), CallStaticIntMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallStaticLongMethod(JNIEnv* env, jclass b, jmethodID c, ...), CallStaticLongMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallStaticLongMethodV(JNIEnv* env, jclass b, jmethodID c, va_list d), CallStaticLongMethodV(env,b,c,d))
WRAP_FUNCTION(CallStaticLongMethodA(JNIEnv* env, jclass b, jmethodID c, jvalue* d), CallStaticLongMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallStaticFloatMethod(JNIEnv* env, jclass b, jmethodID c, ...), CallStaticFloatMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallStaticFloatMethodV(JNIEnv* env, jclass b, jmethodID c, va_list d), CallStaticFloatMethodV(env,b,c,d))
WRAP_FUNCTION(CallStaticFloatMethodA(JNIEnv* env, jclass b, jmethodID c, jvalue* d), CallStaticFloatMethodA(env,b,c,d))
WRAP_VARIADIC_FUNCTION(CallStaticDoubleMethod(JNIEnv* env, jclass b, jmethodID c, ...), CallStaticDoubleMethodV(env,b,c,ap), c)
WRAP_FUNCTION(CallStaticDoubleMethodV(JNIEnv* env, jclass b, jmethodID c, va_list d), CallStaticDoubleMethodV(env,b,c,d))
WRAP_FUNCTION(CallStaticDoubleMethodA(JNIEnv* env, jclass b, jmethodID c, jvalue* d), CallStaticDoubleMethodA(env,b,c,d))
WRAP_VARIADIC_VOID_FUNCTION(CallStaticVoidMethod(JNIEnv* env, jclass b, jmethodID c, ...), CallStaticVoidMethodV(env,b,c,ap), c)
WRAP_VOID_FUNCTION(CallStaticVoidMethodV(JNIEnv* env, jclass b, jmethodID c, va_list d), CallStaticVoidMethodV(env,b,c,d))
WRAP_VOID_FUNCTION(CallStaticVoidMethodA(JNIEnv* env, jclass b, jmethodID c, jvalue* d), CallStaticVoidMethodA(env,b,c,d))
WRAP_FUNCTION(GetStaticFieldID(JNIEnv* env, jclass b, const char* c, const char* d), GetStaticFieldID(env,b,c,d))
WRAP_FUNCTION(GetStaticObjectField(JNIEnv* env, jclass b, jfieldID c), GetStaticObjectField(env,b,c))
WRAP_FUNCTION(GetStaticBooleanField(JNIEnv* env, jclass b, jfieldID c), GetStaticBooleanField(env,b,c))
WRAP_FUNCTION(GetStaticByteField(JNIEnv* env, jclass b, jfieldID c), GetStaticByteField(env,b,c))
WRAP_FUNCTION(GetStaticCharField(JNIEnv* env, jclass b, jfieldID c), GetStaticCharField(env,b,c))
WRAP_FUNCTION(GetStaticShortField(JNIEnv* env, jclass b, jfieldID c), GetStaticShortField(env,b,c))
WRAP_FUNCTION(GetStaticIntField(JNIEnv* env, jclass b, jfieldID c), GetStaticIntField(env,b,c))
WRAP_FUNCTION(GetStaticLongField(JNIEnv* env, jclass b, jfieldID c), GetStaticLongField(env,b,c))
WRAP_FUNCTION(GetStaticFloatField(JNIEnv* env, jclass b, jfieldID c), GetStaticFloatField(env,b,c))
WRAP_FUNCTION(GetStaticDoubleField(JNIEnv* env, jclass b, jfieldID c), GetStaticDoubleField(env,b,c))
WRAP_VOID_FUNCTION(SetStaticObjectField(JNIEnv* env, jclass b, jfieldID c, jobject d), SetStaticObjectField(env,b,c,d))
WRAP_VOID_FUNCTION(SetStaticBooleanField(JNIEnv* env, jclass b, jfieldID c, jboolean d), SetStaticBooleanField(env,b,c,d))
WRAP_VOID_FUNCTION(SetStaticByteField(JNIEnv* env, jclass b, jfieldID c, jbyte d), SetStaticByteField(env,b,c,d))
WRAP_VOID_FUNCTION(SetStaticCharField(JNIEnv* env, jclass b, jfieldID c, jchar d), SetStaticCharField(env,b,c,d))
WRAP_VOID_FUNCTION(SetStaticShortField(JNIEnv* env, jclass b, jfieldID c, jshort d), SetStaticShortField(env,b,c,d))
WRAP_VOID_FUNCTION(SetStaticIntField(JNIEnv* env, jclass b, jfieldID c, jint d), SetStaticIntField(env,b,c,d))
WRAP_VOID_FUNCTION(SetStaticLongField(JNIEnv* env, jclass b, jfieldID c, jlong d), SetStaticLongField(env,b,c,d))
WRAP_VOID_FUNCTION(SetStaticFloatField(JNIEnv* env, jclass b, jfieldID c, jfloat d), SetStaticFloatField(env,b,c,d))
WRAP_VOID_FUNCTION(SetStaticDoubleField(JNIEnv* env, jclass b, jfieldID c, jdouble d), SetStaticDoubleField(env,b,c,d))
WRAP_FUNCTION(NewString(JNIEnv* env, const jchar* b, jsize c), NewString(env,b,c))
WRAP_FUNCTION(GetStringLength(JNIEnv* env, jstring b), GetStringLength(env,b))
WRAP_FUNCTION(GetStringChars(JNIEnv* env, jstring b, jboolean* c), GetStringChars(env,b,c))
WRAP_VOID_FUNCTION(ReleaseStringChars(JNIEnv* env, jstring b, const jchar* c), ReleaseStringChars(env,b,c))
WRAP_FUNCTION(NewStringUTF(JNIEnv* env, const char* b), NewStringUTF(env,b))
WRAP_FUNCTION(GetStringUTFLength(JNIEnv* env, jstring b), GetStringUTFLength(env,b))
WRAP_FUNCTION(GetStringUTFChars(JNIEnv* env, jstring b, jboolean* c), GetStringUTFChars(env,b,c))
WRAP_VOID_FUNCTION(ReleaseStringUTFChars(JNIEnv* env, jstring b, const char* c), ReleaseStringUTFChars(env,b,c))
WRAP_FUNCTION(GetArrayLength(JNIEnv* env, jarray b), GetArrayLength(env,b))
WRAP_FUNCTION(NewObjectArray(JNIEnv* env, jsize b, jclass c, jobject d), NewObjectArray(env,b,c,d))
WRAP_FUNCTION(GetObjectArrayElement(JNIEnv* env, jobjectArray b, jsize c), GetObjectArrayElement(env,b,c))
WRAP_VOID_FUNCTION(SetObjectArrayElement(JNIEnv* env, jobjectArray b, jsize c, jobject d), SetObjectArrayElement(env,b,c,d))
WRAP_FUNCTION(NewBooleanArray(JNIEnv* env, jsize b), NewBooleanArray(env,b))
WRAP_FUNCTION(NewByteArray(JNIEnv* env, jsize b), NewByteArray(env,b))
WRAP_FUNCTION(NewCharArray(JNIEnv* env, jsize b), NewCharArray(env,b))
WRAP_FUNCTION(NewShortArray(JNIEnv* env, jsize b), NewShortArray(env,b))
WRAP_FUNCTION(NewIntArray(JNIEnv* env, jsize b), NewIntArray(env,b))
WRAP_FUNCTION(NewLongArray(JNIEnv* env, jsize b), NewLongArray(env,b))
WRAP_FUNCTION(NewFloatArray(JNIEnv* env, jsize b), NewFloatArray(env,b))
WRAP_FUNCTION(NewDoubleArray(JNIEnv* env, jsize b), NewDoubleArray(env,b))
WRAP_FUNCTION(GetBooleanArrayElements(JNIEnv* env, jbooleanArray b, jboolean* c), GetBooleanArrayElements(env,b,c))
WRAP_FUNCTION(GetByteArrayElements(JNIEnv* env, jbyteArray b, jboolean* c), GetByteArrayElements(env,b,c))
WRAP_FUNCTION(GetCharArrayElements(JNIEnv* env, jcharArray b, jboolean* c), GetCharArrayElements(env,b,c))
WRAP_FUNCTION(GetShortArrayElements(JNIEnv* env, jshortArray b, jboolean* c), GetShortArrayElements(env,b,c))
WRAP_FUNCTION(GetIntArrayElements(JNIEnv* env, jintArray b, jboolean* c), GetIntArrayElements(env,b,c))
WRAP_FUNCTION(GetLongArrayElements(JNIEnv* env, jlongArray b, jboolean* c), GetLongArrayElements(env,b,c))
WRAP_FUNCTION(GetFloatArrayElements(JNIEnv* env, jfloatArray b, jboolean* c), GetFloatArrayElements(env,b,c))
WRAP_FUNCTION(GetDoubleArrayElements(JNIEnv* env, jdoubleArray b, jboolean* c), GetDoubleArrayElements(env,b,c))
WRAP_VOID_FUNCTION(ReleaseBooleanArrayElements(JNIEnv* env, jbooleanArray b, jboolean* c, jint d), ReleaseBooleanArrayElements(env,b,c,d))
WRAP_VOID_FUNCTION(ReleaseByteArrayElements(JNIEnv* env, jbyteArray b, jbyte* c, jint d), ReleaseByteArrayElements(env,b,c,d))
WRAP_VOID_FUNCTION(ReleaseCharArrayElements(JNIEnv* env, jcharArray b, jchar* c, jint d), ReleaseCharArrayElements(env,b,c,d))
WRAP_VOID_FUNCTION(ReleaseShortArrayElements(JNIEnv* env, jshortArray b, jshort* c, jint d), ReleaseShortArrayElements(env,b,c,d))
WRAP_VOID_FUNCTION(ReleaseIntArrayElements(JNIEnv* env, jintArray b, jint* c, jint d), ReleaseIntArrayElements(env,b,c,d))
WRAP_VOID_FUNCTION(ReleaseLongArrayElements(JNIEnv* env, jlongArray b, jlong* c, jint d), ReleaseLongArrayElements(env,b,c,d))
WRAP_VOID_FUNCTION(ReleaseFloatArrayElements(JNIEnv* env, jfloatArray b, jfloat* c, jint d), ReleaseFloatArrayElements(env,b,c,d))
WRAP_VOID_FUNCTION(ReleaseDoubleArrayElements(JNIEnv* env, jdoubleArray b, jdouble* c, jint d), ReleaseDoubleArrayElements(env,b,c,d))
WRAP_VOID_FUNCTION(GetBooleanArrayRegion(JNIEnv* env, jbooleanArray b, jsize c, jsize d, jboolean* e), GetBooleanArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(GetByteArrayRegion(JNIEnv* env, jbyteArray b, jsize c, jsize d, jbyte* e), GetByteArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(GetCharArrayRegion(JNIEnv* env, jcharArray b, jsize c, jsize d, jchar* e), GetCharArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(GetShortArrayRegion(JNIEnv* env, jshortArray b, jsize c, jsize d, jshort* e), GetShortArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(GetIntArrayRegion(JNIEnv* env, jintArray b, jsize c, jsize d, jint* e), GetIntArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(GetLongArrayRegion(JNIEnv* env, jlongArray b, jsize c, jsize d, jlong* e), GetLongArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(GetFloatArrayRegion(JNIEnv* env, jfloatArray b, jsize c, jsize d, jfloat* e), GetFloatArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(GetDoubleArrayRegion(JNIEnv* env, jdoubleArray b, jsize c, jsize d, jdouble* e), GetDoubleArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(SetBooleanArrayRegion(JNIEnv* env, jbooleanArray b, jsize c, jsize d, const jboolean* e), SetBooleanArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(SetByteArrayRegion(JNIEnv* env, jbyteArray b, jsize c, jsize d, const jbyte* e), SetByteArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(SetCharArrayRegion(JNIEnv* env, jcharArray b, jsize c, jsize d, const jchar* e), SetCharArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(SetShortArrayRegion(JNIEnv* env, jshortArray b, jsize c, jsize d, const jshort* e), SetShortArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(SetIntArrayRegion(JNIEnv* env, jintArray b, jsize c, jsize d, const jint* e), SetIntArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(SetLongArrayRegion(JNIEnv* env, jlongArray b, jsize c, jsize d, const jlong* e), SetLongArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(SetFloatArrayRegion(JNIEnv* env, jfloatArray b, jsize c, jsize d, const jfloat* e), SetFloatArrayRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(SetDoubleArrayRegion(JNIEnv* env, jdoubleArray b, jsize c, jsize d, const jdouble* e), SetDoubleArrayRegion(env,b,c,d,e))
WRAP_FUNCTION(RegisterNatives(JNIEnv* env, jclass b, const JNINativeMethod* c, jint d), RegisterNatives(env,b,c,d))
WRAP_FUNCTION(UnregisterNatives(JNIEnv* env, jclass b), UnregisterNatives(env,b))
WRAP_FUNCTION(MonitorEnter(JNIEnv* env, jobject b), MonitorEnter(env,b))
WRAP_FUNCTION(MonitorExit(JNIEnv* env, jobject b), MonitorExit(env,b))
WRAP_FUNCTION(GetJavaVM(JNIEnv* env, JavaVM** b), GetJavaVM(env,b))
WRAP_VOID_FUNCTION(GetStringRegion(JNIEnv* env, jstring b, jsize c, jsize d, jchar* e), GetStringRegion(env,b,c,d,e))
WRAP_VOID_FUNCTION(GetStringUTFRegion(JNIEnv* env, jstring b, jsize c, jsize d, char* e), GetStringUTFRegion(env,b,c,d,e))
WRAP_FUNCTION(GetPrimitiveArrayCritical(JNIEnv* env, jarray b, jboolean* c), GetPrimitiveArrayCritical(env,b,c))
WRAP_VOID_FUNCTION(ReleasePrimitiveArrayCritical(JNIEnv* env, jarray b, void* c, jint d), ReleasePrimitiveArrayCritical(env,b,c,d))
WRAP_FUNCTION(GetStringCritical(JNIEnv* env, jstring b, jboolean* c), GetStringCritical(env,b,c))
WRAP_VOID_FUNCTION(ReleaseStringCritical(JNIEnv* env, jstring b, const jchar* c), ReleaseStringCritical(env,b,c))
WRAP_FUNCTION(NewWeakGlobalRef(JNIEnv* env, jobject b), NewWeakGlobalRef(env,b))
WRAP_VOID_FUNCTION(DeleteWeakGlobalRef(JNIEnv* env, jweak b), DeleteWeakGlobalRef(env,b))
WRAP_FUNCTION(ExceptionCheck(JNIEnv* env), ExceptionCheck(env))
WRAP_FUNCTION(NewDirectByteBuffer(JNIEnv* env, void* b, jlong c), NewDirectByteBuffer(env,b,c))
WRAP_FUNCTION(GetDirectBufferAddress(JNIEnv* env, jobject b), GetDirectBufferAddress(env,b))
WRAP_FUNCTION(GetDirectBufferCapacity(JNIEnv* env, jobject b), GetDirectBufferCapacity(env,b))
WRAP_FUNCTION(GetObjectRefType(JNIEnv* env, jobject b), GetObjectRefType(env,b))
